REGcreate proc hOpenedKey:dword,pszKey:dword,pValueName:dword,pValueData:dword,ValueDataSize:dword,DataType:dword
  local hKey:dword
  local disposition:dword
  local sz_buffer[1024]:byte
	invoke RegCreateKeyEx,hOpenedKey,pszKey,NULL,sz("salafi32"),REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,addr hKey,addr disposition
	.if eax!=ERROR_SUCCESS
		ret
	.endif
	.if pValueData!=NULL
		invoke RegSetValueEx,hKey,pValueName,NULL,DataType,pValueData,ValueDataSize
		.if eax!=ERROR_SUCCESS
			push eax
			invoke RegCloseKey,hKey
			pop eax
			ret
		.endif
	.endif
	invoke RegCloseKey,hKey
	return ERROR_SUCCESS
REGcreate endp

REGdelete_key proc hOpenedKey:dword,pszKey:dword
  local szSubKey[1024]:byte
  local dwSizeSubKey:dword
  local dwTimeSubKey:dword
  local hKey:dword
	invoke RegOpenKeyEx,hOpenedKey,pszKey,NULL,KEY_ALL_ACCESS,addr hKey
	.if eax!=ERROR_SUCCESS
		ret
	.endif
KillNextSubKey:
	mov dwSizeSubKey,sizeof szSubKey
	invoke RegEnumKeyEx,hKey,0,addr szSubKey,addr dwSizeSubKey,NULL,NULL,NULL,addr dwTimeSubKey
	.if eax!=ERROR_NO_MORE_ITEMS
		invoke REGdelete_key,hKey,addr szSubKey
		.if eax!=ERROR_SUCCESS
			push eax
			invoke RegCloseKey,hKey
			pop eax
			ret
		.endif
		jmp KillNextSubKey
	.endif
	invoke RegCloseKey,hKey
	invoke RegDeleteKey,hOpenedKey,pszKey
	.if eax!=ERROR_SUCCESS
		ret
	.endif
	return ERROR_SUCCESS
REGdelete_key endp

REGdelete_value proc hOpenedKey:dword,pszKey:dword,pszValue:dword
  local hKey:dword
	invoke RegOpenKeyEx,hOpenedKey,pszKey,NULL,KEY_ALL_ACCESS,addr hKey
	.if eax!=ERROR_SUCCESS
		ret
	.endif
	invoke RegDeleteValue,hKey,pszValue
	.if eax!=ERROR_SUCCESS
		push eax
		invoke RegCloseKey,hKey
		pop eax
		ret
	.endif
	invoke RegCloseKey,hKey
	return ERROR_SUCCESS
REGdelete_value endp

REGget_value proc hOpenedKey:dword,pszKey:dword,pszValue:dword,pBuffer:dword,pSizeOfBuffer:dword
  local hKey:dword
	invoke RegOpenKeyEx,hOpenedKey,pszKey,NULL,KEY_ALL_ACCESS,addr hKey
	.if eax!=ERROR_SUCCESS
		ret
	.endif
	invoke RegQueryValueEx,hKey,pszValue,NULL,NULL,pBuffer,pSizeOfBuffer
	.if eax!=ERROR_SUCCESS
		push eax
		invoke RegCloseKey,hKey
		pop eax
		ret
	.endif
	invoke RegCloseKey,hKey
	return ERROR_SUCCESS
REGget_value endp