;==========================================
;created with ==>MASM IDE version 3.3
;written by "salafi"
;email==>i_am_salafi@hotmail.com
;web site==>www.teckproject.4t.com
;==========================================

.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\ole32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib  \masm32\lib\ole32.lib

include \masm32\COM\include\oaidl.inc
include \masm32\COM\include\component.inc

include my_macros.asm

KeyUp PROTO :dword

sCLSID_RichEdit TEXTEQU <{0B96599F9h,0A4FDh,04C60h,{092h,02Dh,09Fh,0FCh,035h,098h,008h,0F7h}}>
sIID_RichEdit TEXTEQU <{0843B976Eh,08FFCh,042B8h,{088h,043h,058h,0F2h,064h,0F9h,049h,061h}}>
sLIBID_RichEdit TEXTEQU <{07CC83E77h,09593h,046A6h,{0B9h,095h,009h,0AEh,007h,067h,091h,0DEh}}>

sIID_Events TEXTEQU <{011E6C8F3h,07817h,04654h,{092h,0F2h,085h,077h,073h,0DFh,071h,05Bh}}>

IRichEdit STRUCT
	IRichEdit_QueryInterface comethod3 ?
	IRichEdit_AddRef comethod1 ?
	IRichEdit_Release comethod1 ?
	IRichEdit_Initialize comethod6 ?
	IRichEdit_Uninitialize comethod1 ?
	IRichEdit_LoadFromFile comethod2 ?
	IRichEdit_SaveToFile comethod2 ?
	IRichEdit_InsertText comethod2 ?
	IRichEdit_GoToLine comethod2 ?
	IRichEdit_GetLinesCount comethod2 ?
	IRichEdit_GetNowLine comethod2 ?

	IRichEdit_EnumConnectionPoints comethod2 ?
	IRichEdit_FindConnectionPoint comethod3 ?
IRichEdit ENDS

IEvents STRUCT
	IEvents_QueryInterface comethod3 ?
	IEvents_AddRef comethod1 ?
	IEvents_Release comethod1 ?

	IEvents_GetConnectionInterface comethod2 ?
	IEvents_GetConnectionPointContainer comethod2 ?
	IEvents_Advise comethod3 ?
	IEvents_Unadvise comethod2 ?
	IEvents_EnumConnections comethod2 ?
IEvents ENDS

ISink STRUCT
;	ISink_QueryInterface comethod3 ?
;	ISink_AddRef comethod1 ?
;	ISink_Release comethod1 ?

	ISink_KeyUp comethod1 ?
ISink ENDS

SinkObject STRUCT
	lpVtbl dd 0
	nRefCount dd 1
SinkObject ENDS

IDM_LOAD_FILE EQU 1
IDM_SAVE_FILE EQU 2
IDM_INSERT_TEXT EQU 3
IDM_GET_LINES_COUNT EQU 4
IDM_GO_TO_LINE EQU 5
IDM_GET_NOW_LINE EQU 6

.data
	szAppName db "Rich Edit COM component Demo",0
	hInstance dd ?
	szbuffer db 1024 dup(0)
	dw_ dd ?
	h_wnd dd ?

	CLSID_RichEdit GUID sCLSID_RichEdit
	IID_RichEdit GUID sIID_RichEdit
	IID_ConnectionPointContainer GUID sIID_IConnectionPointContainer
	IID_ConnectionPoint GUID sIID_IConnectionPoint

	vtblSink ISink<KeyUp>
	sink SinkObject<offset vtblSink,0>

	pIRiched dd ?
	pContainer dd ?
	pConnectionPoint dd ?
	dwCookie dd ?

.code
start:
	call init_com
	.if eax==FALSE
		call uninit_com
		jmp exit
	.endif
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	call WinMain
	call uninit_com
exit:
	invoke ExitProcess, eax

WinMain proc
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize, SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground, COLOR_BTNSHADOW
	mov   wc.lpszMenuName,sz_("menu")
	mov   wc.lpszClassName,sz_("ossama32")
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
	mov   wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,sz("ossama32"),ADDR szAppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL
	mov   hwnd, eax
	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	@@:
		invoke GetMessage, ADDR msg, NULL, 0, 0
		cmp eax,0
		je @F
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
		jmp @B
	@@:
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND,message:UINT, wParam:WPARAM, lParam:LPARAM

	.if message==WM_CREATE
		coinvoke pIRiched,IRichEdit,Initialize,hWnd,10,10,300,300
		m2m h_wnd,hWnd
	.elseif message==WM_COMMAND
		.if lParam==0
			mov eax,wParam
			.if ax==IDM_LOAD_FILE
				coinvoke pIRiched,IRichEdit,LoadFromFile,sz("c:\masm32\bin\demo.asm")
			.elseif ax==IDM_SAVE_FILE
				coinvoke pIRiched,IRichEdit,SaveToFile,sz("C:\Documents and Settings\salafii\Desktop\look_here.txt")
			.elseif ax==IDM_INSERT_TEXT
				coinvoke pIRiched,IRichEdit,InsertText,sz("inserted text")
			.elseif ax==IDM_GET_LINES_COUNT
				coinvoke pIRiched,IRichEdit,GetLinesCount,addr dw_
				invoke wsprintf,addr szbuffer,sz("lines count = %ld"),dw_
				invoke MessageBox,hWnd,addr szbuffer,addr szAppName,MB_OK
			.elseif ax==IDM_GO_TO_LINE
				coinvoke pIRiched,IRichEdit,GoToLine,2	;go to line number 2
			.elseif ax==IDM_GET_NOW_LINE
				coinvoke pIRiched,IRichEdit,GetNowLine,addr dw_
				invoke wsprintf,addr szbuffer,sz("Now Line = %ld"),dw_
				invoke MessageBox,hWnd,addr szbuffer,addr szAppName,MB_OK
			.endif
		.endif
	.elseif message==WM_DESTROY
		coinvoke pIRiched,IRichEdit,Uninitialize
		invoke PostQuitMessage, NULL
	.else
		invoke DefWindowProc, hWnd,message, wParam, lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

KeyUp proc this_:dword
	coinvoke pIRiched,IRichEdit,GetNowLine,addr dw_
	invoke wsprintf,addr szbuffer,sz("Now Line = %ld"),dw_
	invoke SetWindowText,h_wnd,addr szbuffer
	return S_OK
KeyUp endp

init_com proc
	invoke CoInitialize,NULL
	.if eax!=S_OK
		invoke MessageBox,0,sz("error:init com library"),addr szAppName,MB_OK+MB_ICONERROR
		return FALSE
	.endif
	invoke CoCreateInstance,addr CLSID_RichEdit,NULL,CLSCTX_INPROC_SERVER,addr IID_RichEdit,addr pIRiched
	.if eax!=S_OK
		invoke MessageBox,0,sz("error:create object"),addr szAppName,MB_OK+MB_ICONERROR
		return FALSE
	.endif

	coinvoke pIRiched,IRichEdit,QueryInterface,addr IID_ConnectionPointContainer,addr pContainer
	.if eax!=S_OK
		invoke MessageBox,0,sz("error:container"),addr szAppName,MB_OK+MB_ICONERROR
		return FALSE
	.endif
	coinvoke pContainer,IRichEdit,FindConnectionPoint,addr IID_ConnectionPoint,addr pConnectionPoint
	.if eax!=S_OK
		invoke MessageBox,0,sz("error:connection point"),addr szAppName,MB_OK+MB_ICONERROR
		return FALSE
	.endif
	coinvoke pConnectionPoint,IEvents,Advise,addr sink,addr dwCookie
	.if eax!=S_OK
		invoke MessageBox,0,sz("error:sink advise"),addr szAppName,MB_OK+MB_ICONERROR
		return FALSE
	.endif

	return TRUE
init_com endp

uninit_com proc
	coinvoke pConnectionPoint,IEvents,Unadvise,addr dwCookie
	coinvoke pConnectionPoint,IEvents,Release
	coinvoke pContainer,IRichEdit,Release

	coinvoke pIRiched,IRichEdit,Release
	invoke CoUninitialize
	return TRUE
uninit_com endp

end start