;*********************************************************************
;*********************************************************************
;my macros version 2.0
;*********************************************************************
;*********************************************************************

;================================================
sz MACRO quoted_text:VARARG	;this is used in INVOKE
  local local_text
	.data
		local_text db quoted_text,0
	.code
		EXITM <addr local_text>
ENDM

sz_ MACRO quoted_text:VARARG
  local local_text
	.data
		local_text db quoted_text,0
	.code
		EXITM <offset local_text>
ENDM

szText MACRO name_:REQ,quoted_text:VARARG
	local lbl
	jmp lbl
	name_ db quoted_text,0
lbl:
ENDM

sz_size MACRO quoted_text:VARARG	;this is used in INVOKE
  local local_text
	.data
		local_text db quoted_text,0
	.code
		EXITM <addr local_text,sizeof local_text>
ENDM

sz_len MACRO quoted_text:VARARG	;this is used in INVOKE
  local local_text
  local local_text2
	.data
		local_text db quoted_text,0
		local_text2 dd ?
	.code
		invoke lstrlen,addr local_text
		inc eax
		mov local_text2,eax
		EXITM <addr local_text,local_text2>
ENDM

sz_len_ MACRO the_variable:REQ
  local local_text
	.data
		local_text dd ?
	.code
		invoke lstrlen,addr the_variable
		inc eax
		mov local_text,eax
		EXITM <addr the_variable,local_text>
ENDM

;================================================
return MACRO arg:REQ
	mov eax,arg
	ret
ENDM
;================================================
m2m MACRO arg1:REQ,arg2:REQ
	push arg2
	pop   arg1
ENDM
;================================================
make_dword MACRO high_word:REQ,low_word:REQ
	push ax	;we do this to preserve the value of ax if ax is passed th this macro as the first parameter
	mov ax,high_word
	shl eax,16
	pop ax		;we do this to preserve the value of ax if ax is passed th this macro as the first parameter
	mov ax,low_word
	exitm<eax>
ENDM
;================================================
func MACRO the_function:VARARG
  local local_var
.data
	local_var dd ?
.code
	invoke the_function
	mov local_var,eax
	exitm <local_var>
ENDM
;================================================
func_ MACRO the_function:REQ,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22
  local local_var
.data
	local_var dd ?
.code
	FOR arg,<p22,p21,p20,p19,p18,p17,p16,p15,p14,p13,p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>
	IFNB <arg>    ;; If not blank
	push arg    ;; push parameter
	ENDIF
	ENDM
	call the_function
	mov local_var,eax
	exitm <local_var>
ENDM
;================================================
zero_memory MACRO pszbuffer:REQ,dwsize:REQ
  local start_loop
  local end_loop
	push dwsize
	push pszbuffer
	pop edx
	pop ecx
	mov al,0
start_loop:
	cmp ecx,0
	je end_loop
	mov [edx],al
	inc edx
	dec ecx
	jmp start_loop
end_loop:
ENDM
;================================================
p2v MACRO var:REQ,ptr:REQ
	mov edx,ptr
	mov eax,[edx]
	mov var,eax
ENDM
;================================================
rgb MACRO red:REQ,green:REQ,blue:REQ
	xor eax,eax
	mov al,blue
	shl eax,16
	mov ah,green
	mov al,red
	EXITM <eax>
ENDM

flags_check MACRO src_flags:REQ,test_flags:REQ
	FOR arg, <src_flags,test_flags>
		IFIDNI <&arg>,<eax>
			.ERR <eax is not allowed as a parameter>
		ENDIF
	ENDM
	mov eax,src_flags
	and eax,test_flags
	.if eax==test_flags
		mov eax,TRUE
	.else
		mov eax,FALSE
	.endif
	EXITM <eax>
ENDM